@Comment{$Header: overview.mss,v 1.2 88/12/02 10:50:20 jtkohl Exp $}
@Comment{$Source: /mit/zephyr/doc/techplan/RCS/overview.mss,v $}
@Comment{$Author: jtkohl $}
@Comment{$Revision: 1.2 $}
@Comment{Copyright 1988 Massachusetts Institute of Technology}
@Part[overview, Root "zephyr.mss"]

@Begin(Comment)
Random Editorial Comments ---------------------------------------------------

This is an overview of the pieces of Zephyr

-----------------------------------------------------------------------------
@End(Comment)

@Chap{An overview of Zephyr's Components}

@section(Notice transport)
Zephyr's notice transport mechanism involves two major components, the
Server and the HostManager.

The server provides the user location service and the subscription
service.  All notices delivered via Zephyr are routed through at least
one Zephyr server.  There are typically a small number of Zephyr servers
for each site using Zephyr.

The HostManager provides a reliable contact point for clients.  Each
host supporting Zephyr runs a HostManager, which locates a server and
routes any notices sent by clients to the server.  If a server becomes
unreachable, the HostManager will attempt to contact a new server.
By placing this functionality in one place, the server's job of
detecting host failures is made easier, since it has a known contact
point.  In addition, the clients become less complicated as they need
not find and establish communication with a server.

@section(Clients)
Client programs use the notice transport mechanism to deliver and
receive notices across the network.  Clients send notices to a Zephyr
server (via the HostManager) to establish a subscription.  Other clients
send notices to servers for redistribution to clients.  The recipients
of the redistributed notice are determined by the subscription service.

@begin(FullPageFigure)
@caption<A typical exchange between clients>
@tag(ovfig)
@picture(Size=5.5 inches, ScaleableLaser="ovfig.PS")

@begin(transparent, fill, above 0, below 0, Font Headingfont)
The arrows labeled @b(A, B, C, C1, C2, D) depict notices involved in
establishing a subscription.  The WindowGram client requests a
subscription by transmitting a notice to the HostManager (A), which
forwards it to a server (B).  The server responds with an
acknowledgment (C) which is forwarded to the client (D).  The server
also forwards the request to the other servers (C1, C2).

The arrows labeled @b(1, 2, 3, 4a, 4b, 5) depict notices involved in
sending a notice from one client to another.  A user on one host sends a
notice to another user on a different host by sending the notice to the
local HostManager (1), which forwards the notice to its server (2).  The
server transmits the notice to the other user (3), and then acknowledges
the notice to the sender (4a).  The recipient acknowledges receipt of
the notice (4b).  The HostManager forwards the server acknowledgment to
the sender (5).
@end(transparent)
@end(FullPageFigure)
Figure@ @ref(ovfig) shows a typical interaction between clients,
HostManagers and servers.
