@Comment{$Header: prereq.mss,v 1.2 88/12/02 10:50:59 jtkohl Exp $}
@Comment{$Source: /mit/zephyr/doc/techplan/RCS/prereq.mss,v $}
@Comment{$Author: jtkohl $}
@Comment{$Revision: 1.2 $}
@Comment{Copyright 1988, Massachusetts Institute of Technology}
@Part[prereq, Root "zephyr.mss"]

@Begin(Comment)
Random Editorial Comments ---------------------------------------------------

-----------------------------------------------------------------------------
@End(Comment)

@Chap{Prerequisites assumed for the use of Zephyr}
@begin(Description)
Networked environment@\Zephyr is designed for use in
a networked environment of (marginally) cooperating hosts.  For a
stand-alone single-user or timesharing system, it offers very little
advantage over standard @c(Unix) utilities such as @i(write) and
@i(talk).

High-speed network@\Zephyr assumes the availability of a high-speed
network for communication between hosts within a given Zephyr cell.
If a high-speed network is not available, many of the implicit
assumptions are no longer correct and the system may not perform
adequately.  There is @i(no) requirement for broadcast capability.

Authentication@\Zephyr assumes the presence of an authentication system
which is secure on the network over which it operates.  Because of its
flexibility, Zephyr needs a way to reliably determine the sender of any
given notice.  Without an authentication system in place, the
reliability of this identification is highly suspect, and the ability to
spoof Zephyr becomes easy (If Zephyr is being operated in a captive, friendly,
cooperative environment, this may not be a cause for concern.).

Administration@\The Zephyr server is designed to run indefinitely without
intervention.

@end(Description)
@Chap{Prerequisites assumed for the current implementation of Zephyr}
UDP/IP@\Zephyr as implemented uses its own protocol built on UDP/IP.
However, it could be implemented using a non-blocking remote
procedure call interface, or using some other datagram-style network
protocol.

BSD 4.2/4.3@\As a consequence of the use of UDP/IP, the current
implementation requires the Berkeley socket interface to UDP/IP.  Zephyr
as run at M.I.T. is implemented on 4.3BSD systems, but it has been
compiled and tested on 4.2BSD-based systems.

X Window system@\The standard Zephyr client program uses the X Window
System to display notices to the user.  It has an alternate
terminal-based display mode, similar to @i(write).  Another display
interface could be added.

Dedicated servers@\When Kerberos is in use, the current implementation
of the server must perform an authentication check on any incoming
notice which purports to be authentic.  This takes about 200
milliseconds of CPU time.  In addition, the database of subscriptions
and locations is maintained in the virtual memory of the server process.
For large sites this can mean a large core image.  As a result, the
Zephyr server is best run on a dedicated processor with a reasonable
amount of main memory.

Name service@\The current implementation uses the Hesiod name service to
locate the Zephyr servers.  It can be configured, however, to determine
which hosts are servers by reading configuration files.
