@Comment{$Header: windowgram.mss,v 1.2 88/12/02 16:02:10 jtkohl Exp $}
@Comment{$Source: /mit/zephyr/doc/techplan/RCS/windowgram.mss,v $}
@Comment{$Author: jtkohl $}
@Comment{$Revision: 1.2 $}
@Comment{Copyright 1987, Massachusetts Institute of Technology}
@Part[windowgram, Root "zephyr.mss"]

@Begin(Comment)
Random Editorial Comments ---------------------------------------------------

-----------------------------------------------------------------------------
@End(Comment)
@process(PageHeadings)

@Chap(The WindowGram Client and Browser)
@Label(windowgram)

@Section(Overview)

The Zephyr WindowGram client is the primary Zephyr user application.  It
displays incoming notices on the user's screen as directed by a
description file.  The WindowGram browser allows the user to save
notices and review them later.  The WindowGram client and browser are
the only sections of the Zephyr system that will be immediately obvious
to the naive user.

@Section(Client Operation)

When a user logs in, a WindowGram client is automatically started for
him or her by the standard initialization files. The WindowGram client
registers the user with the user location database, using the last
exposure set by the user (or a system default if the user has never set
his own exposure), sends the user's standard subscriptions to the
server, executes the user's initialization program (or the system
initialization program if the user has not specified his own), reads the
user's description file and the system default description file.

The WindowGram client then waits for incoming notices on an allocated
port.  When a notice is received, it is matched against the description
file and, if no match was found, against the system default description
file, and is acted upon appropriately.

In addition to notices delivered by the normal client-server path,
the WindowGram client may also receive incoming packets
directly from user applications programs that instruct it to perform
special functions.

The WindowGram client will work whether or not the user is using an X
Window System (``X'') display.  If the client is not using X, a simple
terminal-based display (similar to the @c(UNIX) @i(write) utility) will
be provided.  The user may, if desired, select the simple terminal-based
display while using an X display.

If the client is using X, the WindowGram browser can be used.  The
browser waits for commands from the user (via mouse or keyboard),
allowing the user to scroll through the notices he has received, discard
those he doesn't want, or save certain notices in files.

A similar browser will be available in the future as a separate
application for clients not running X.

When the user logs out, the system delivers a SIGHUP to the WindowGram
client, which then deregisters the user from the user location service,
and cancels all its subscriptions.

@Section(WindowGram Subsystems)
The WindowGram client is composed of the following subsystems. The client
waits until any of several input channels (file descriptors) is ready,
and then the appropriate subsystem is invoked to respond to the channel.

@SubSection{Notice Handler}

When the WindowGram client receives a notice, its class, instance and
origin are checked.  If the class is ``WG_CTL,'' the instance is
``USER'' and the origin is the local host, the notice is passed on to
the WINDOWGRAM_CTL handler.  Otherwise, the notice is displayed by the
Display Handler as directed by the description files.

@SubSection{WINDOWGRAM_CTL Handler}

When the WINDOWGRAM_CTL handler is invoked, the notice opcode is
examined, and the following actions are taken:
@begin(itemize)
If the opcode is ``REREAD,'' the user's description file is re-read.

If the opcode is ``SHUTDOWN,'' the user's current subscriptions are
retrieved and saved, and then the subscriptions are canceled.  In
addition, the client ignores all further notices except ``WG_CTL''
notices.  This state is called ``catatonia''

If the opcode is ``STARTUP,'' the saved subscriptions are re-subscribed
to and the client resumes normal operation.  If the client was not in
``catatonia,'' there is no effect.
@end(itemize)
Because these notices are sent directly to the client from another
client on the same host, there is no need to subscribe to these notices.

The WindowGram client will make sure that the packets are authentic
(from the proper user) before performing any of the above operations.

@SubSection{Display Handler}

When a notice arrives, the Display Handler composes a displayable form
using the format specified in the description file. It then displays
the notice. The actual display is based on the type of display
interface and description file used. The display interfaces available
are:

@begin{itemize}
X Window System Display

Generic terminal
@end{itemize}

Any other interface that can control a file descriptor (for
@i{select(2)}) or interrupt the program can be integrated into the
existing client.
