@use(database "/mit/zephyr/doc/techplan/")
@Comment{$Header: zephyr.mss,v 1.2 88/12/02 16:33:39 jtkohl Exp $}
@Comment{$Source: /mit/zephyr/doc/techplan/RCS/zephyr.mss,v $}
@Comment{$Author: jtkohl $}
@Comment{$Revision: 1.2 $}
@Comment{Copyright 1987,1988 Massachusetts Institute of Technology}

@Begin(Comment)
Random Editorial Comments ---------------------------------------------------

This is the master file for the Athena Technical Plan chapter for Zephyr

-----------------------------------------------------------------------------
@End(Comment)

@Device(PostScript)
@Make(Plan)
@LibraryFile(STable)
@Style(
	References = STDNumeric,
	Hyphenation On,
	WidowAction Force,
	OrphanAction Force,
	FontFamily AllPSFonts
)

@Comment{
    All these modifications and definitions need to be before the @PlanHead
    (the first text generating command) so that the definitions are
    available for scribing by parts.
}
@Style(ExceptionDictionary="zephyr")
@Equate(Chap=MajorSection)
@Equate(Append=MajorSection)
@Equate(SubSubSection=Paragraph)

@Modify(Description, Above 2 lines, Below 2 lines)
@Modify(Enumerate, Above 2 lines, Below 2 lines)
@Modify(Itemize, Above 2 lines, Below 2 lines)

@Define(F, FaceCode F)
@Define(SM=Transparent, Size -2)

@Define(ColStyle1=FlushLeft)
@Define(ColStyle2=Text, LineWidth 2.25 inches, Indent 0)
@DefineRowFormat(
	TableHeadFmt,
	Boxtype StandardBox,
	FlushTop,
	Columns=[
		Column Center,
		Column Combined,
		Column Combined,
		Column Combined
	]
)
@DefineRowFormat(
	ColumnHeadFmt,
	BoxType StandardBox,
	FlushTop,
	Columns=[
		Column Center,
		Column Center,
		Column Center,
		Column Center
	]
)
@DefineRowFormat(
	BodyRowFmt,
	FlushTop,
	Columns=[
		Column ColStyle1,
		LineType StandardLineType,
		Column ColStyle1,
		LineType StandardLineType,
		Column ColStyle1,
		LineType StandardLineType,
		Column ColStyle2
	]
)
@String(Name="Zephyr")
@String(Namep="Zephyr's")

@String(ZephyrVersion=<$Header: zephyr.mss,v 1.2 88/12/02 16:33:39 jtkohl Exp $>)

@String(
	VersionDate="@Value(Date)",
        PlanSection="Section E.4.1",
        Title="Zephyr Notification Service",
        FootingTitle="Zephyr Notification Service",
        CopyrightDate="1987,1988",
        Author="by C. Anthony DellaFera,
		John T. Kohl,
		Mark W. Eichin,
		Robert S. French,
		David C. Jedlinsky,
		William E. Sommerfeld"
)

@TabClear()
@Planhead(VersionDate="@value(VersionDate)",
        PlanSection="@value(PlanSection)",
        Title="@value(Title)",
        FootingTitle="@value(FootingTitle)",
        CopyrightDate="@value(CopyrightDate)",
        Author="@value(Author)"
)

@TabClear()
@TabDivide(8)
@Comment{Ok, now include all the document parts:  }

@Include[titlepage.mss]
@Include[intro.mss]
@Include[overview.mss]
@Include[protocol.mss]
@Include[server.mss]
@Include[hostmanager.mss]
@include[lib.mss]
@Include[windowgram.mss]
@Include[ack.mss]
@Include[ref.mss]
